//+------------------------------------------------------------------+
//|                           Copyright 2005,  bobammax              |
//| Some new features were added                                     |
//| by newdigital from http://www.forex-tsd.com/forum.php            |
//| - working hours selection.                                       |
//|   EA will process any opened orders within working hours         |
//|   but will not open new one;                                     |
//| - Period of trading should be selected now                       |
//|   (PeriodTrading = 240 is H4);                                   |
//| - Ichimoku setting may be selected                               |
//|   (Tenkan_sen, Kijun_sen and Senkou_Span_B).                     |
//|   Classical settings is 9, 26 and 52.                            |
//|   Other possible settings are the following:                     |
//|   M5 72-144-288; H1 12-24-120 or 120-240-480;                    |
//|   D1 5-10-20 or 9-26-52; W1 9-26-52; etc.                        |
//| http://www.forex-tsd.com/forum.php                               |
//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert    = "Ichimoku5_3";
extern bool   EcnBroker      = true;
extern string SymbolsPrefix  = "";
extern string SymbolsSuffix  = "";
extern bool   UseAutoMagic   = true;
extern int    ManualMagic    = 91919191;  
extern double lStopLoss      = 37;
extern double sStopLoss      = 35;
extern double lTakeProfit    = 80;
extern double sTakeProfit    = 75;
extern double lTrailingStop  = 20;
extern double sTrailingStop  = 20;
extern int    Slippage       = 4;
extern double Lots           = 0.1;
extern double MaximumRisk    = 0;
extern double DecreaseFactor = 3;

extern int    TenkanKijunTf  = 240;
extern int    Tenkan         = 9;
extern int    Kijun          = 26;
extern int    MaTimeframe    = 240;
extern int    MaPeriod       = 34;
extern int    MaType         = MODE_EMA;
extern int    bar            = 1;

extern string _time          = "Time Filter";
extern int    StartHour      = 0;          // Start Hour of Trade Session 
extern int    StartMinute    = 0;          // Start Minute of Trade Session 
extern int    EndHour        = 23;         // End Hour of Trade Session
extern int    EndMinute      = 0;          // End Hour of Trade Session


extern color  clOpenBuy      = Blue;
extern color  clCloseBuy     = Aqua;
extern color  clOpenSell     = Red;
extern color  clCloseSell    = Violet;
extern color  clModiBuy      = Blue;
extern color  clModiSell     = Red;

//
//
//
//
//

double pipMultiplier = 1;
string s_symbol;
int    MAGIC;

//
//
//
//
//

int init() 
{

  s_symbol = Symbol();
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//
//
//
//
//

int deinit() 
{   
   Comment(""); 

return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (Digits == 3 || Digits == 5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;  
   
   //
   //
   //
   //
   //
   
   if(Bars < 100) { Print("bars less than 100"); return(0); }
   
   //
   //
   //
   //
   //
   
   if(lStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(lTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   if(sStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(sTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   
   //
   //
   //
   //
   //
   
   double diCustom0 = iCustom(NULL,TenkanKijunTf,"Tenkan Sen-Kijun Sen", Tenkan,Kijun,0,bar);
   double diCustom1 = iCustom(NULL,TenkanKijunTf,"Tenkan Sen-Kijun Sen", Tenkan,Kijun,1,bar);
   double diCustom2 = iCustom(NULL,TenkanKijunTf,"Tenkan Sen-Kijun Sen", Tenkan,Kijun,1,bar);
   double diCustom3 = iCustom(NULL,TenkanKijunTf,"Tenkan Sen-Kijun Sen", Tenkan,Kijun,1,bar+1);
   double diMA3     = iMA(NULL,MaTimeframe,MaPeriod,0,MaType,PRICE_CLOSE,bar);
   double diMA4     = iMA(NULL,MaTimeframe,MaPeriod,0,MaType,PRICE_CLOSE,bar+1);

   
   if (!ExistPositions())
   {

      if (diCustom0 > diCustom1 && diCustom2 > diMA3 && diCustom3 <= diMA4 && TimeCondition())
      {
         OpenBuy();
         return(0);
      }

      if (diCustom0 < diCustom1 && diCustom2 < diMA3 && diCustom3 >= diMA4 && TimeCondition())
      {
         OpenSell();
         return(0);
      }
   }
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(True);
			}
		} 
	} 
return(false);
}

//
//
//
//
//

void TrailingPositionsBuy(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid - OrderOpenPrice()     > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss()   < Bid - trailingStop * Point * pipMultiplier) 
                     ModifyStopLoss(Bid       - trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() > Ask + trailingStop * Point * pipMultiplier || OrderStopLoss() == 0)  
                     ModifyStopLoss(Ask     + trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  Print(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = GetStopLossBuy(); 
   double lbTake = GetTakeProfitBuy();
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if  (buyTicket   >= 0)
            bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           Print(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   double lsStop = GetStopLossSell(); 
   double lsTake = GetTakeProfitSell();
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int  sellTicket   = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if  (sellTicket  >= 0)
            bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           Print(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
          }
    }		       
}

//
//
//
//
//

double GetStopLossBuy()    { 	return(Bid - lStopLoss   * Point * pipMultiplier); } 
double GetStopLossSell()   { 	return(Ask + sStopLoss   * Point * pipMultiplier); } 
double GetTakeProfitBuy()  { 	return(Ask + lTakeProfit * Point * pipMultiplier); } 
double GetTakeProfitSell() { 	return(Bid - sTakeProfit * Point * pipMultiplier); } 

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract = MarketInfo(Symbol(),MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses    = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit()>0) break;
      if(OrderProfit()<0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
   //
   //
   //
   //
   //
   
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(91933921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(91933922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(91933931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(91933932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(91933941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(91933942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(91933951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(91933961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(91933962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(91933963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(91933964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(91933965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(91933966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(91933967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(91933971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(91933972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(91933973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(91933981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(91933982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(91933983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(91933991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(91933992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(91933993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(91933994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(91933995);
   
return(ManualMagic);
}

//
//
//
//
//

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd; 
        
   else
   
   if (StartHour > EndHour)
   result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24) || (TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   
   return(result);
}  